/* Generated automatically by the program `genemit'
from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"
#include "dfp.h"
#include "output.h"
#include "recog.h"
#include "df.h"
#include "resource.h"
#include "reload.h"
#include "diagnostic-core.h"
#include "regs.h"
#include "tm-constrs.h"
#include "ggc.h"
#include "target.h"

/* ../../gcc/config/sparc/sparc.md:1723 */
rtx
gen_movsi_high_pic (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_HIGH (SImode,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		operand1),
	0)));
}

/* ../../gcc/config/sparc/sparc.md:2014 */
rtx
gen_sethh (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_HIGH (DImode,
	gen_rtx_UNSPEC (DImode,
	gen_rtvec (1,
		operand1),
	7)));
}

/* ../../gcc/config/sparc/sparc.md:2086 */
rtx
gen_embmedany_textlo (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_LO_SUM (DImode,
	operand1,
	operand2));
}

/* ../../gcc/config/sparc/sparc.md:3659 */
rtx
gen_fix_truncsfsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_FIX (SImode,
	gen_rtx_FIX (SFmode,
	operand1)));
}

/* ../../gcc/config/sparc/sparc.md:4291 */
rtx
gen_subvdi4_sp32 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (gen_rtx_REG (CCVmode,
	100),
	gen_rtx_COMPARE (CCVmode,
	gen_rtx_MINUS (DImode,
	operand1,
	operand2),
	gen_rtx_UNSPEC (DImode,
	gen_rtvec (2,
		copy_rtx (operand1),
		copy_rtx (operand2)),
	63))),
		gen_rtx_SET (operand0,
	gen_rtx_MINUS (DImode,
	copy_rtx (operand1),
	copy_rtx (operand2)))));
}

/* ../../gcc/config/sparc/sparc.md:5015 */
rtx
gen_const_umulsi3_highpart (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_TRUNCATE (SImode,
	gen_rtx_LSHIFTRT (DImode,
	gen_rtx_MULT (DImode,
	gen_rtx_ZERO_EXTEND (DImode,
	operand1),
	operand2),
	const_int_rtx[MAX_SAVED_CONST_INT + (32)])));
}

/* ../../gcc/config/sparc/sparc.md:5305 */
rtx
gen_udivsi3_sp64 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UDIV (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/sparc/sparc.md:5467 */
rtx
gen_xorsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_XOR (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/sparc/sparc.md:6071 */
rtx
gen_subsf3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MINUS (SFmode,
	operand1,
	operand2));
}

/* ../../gcc/config/sparc/sparc.md:6347 */
rtx
gen_negsf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_NEG (SFmode,
	operand1));
}

/* ../../gcc/config/sparc/sparc.md:6668 */
rtx
gen_lshrsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_LSHIFTRT (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/sparc/sparc.md:7460 */
rtx
gen_flushdi (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		operand0),
	5);
}

/* ../../gcc/config/sparc/sparc.md:7871 */
rtx
gen_trap (void)
{
  return gen_rtx_TRAP_IF (VOIDmode,
	const1_rtx,
	const_int_rtx[MAX_SAVED_CONST_INT + (5)]);
}

/* ../../gcc/config/sparc/sparc.md:7942 */
rtx
gen_tgd_addsi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_PLUS (SImode,
	operand1,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (2,
		operand2,
		operand3),
	17)));
}

/* ../../gcc/config/sparc/sparc.md:7997 */
rtx
gen_tldo_hix22si (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_HIGH (SImode,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		operand1),
	19)));
}

/* ../../gcc/config/sparc/sparc.md:8028 */
rtx
gen_tie_lo10si (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_LO_SUM (SImode,
	operand1,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		operand2),
	20)));
}

/* ../../gcc/config/sparc/sparc.md:8393 */
rtx
gen_stack_protect_test32 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (gen_rtx_REG (CCmode,
	100),
	gen_rtx_UNSPEC (CCmode,
	gen_rtvec (2,
		operand0,
		operand1),
	43)),
		gen_rtx_SET (gen_rtx_SCRATCH (SImode),
	const0_rtx),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sparc/sparc.md:8601 */
rtx
gen_iorv4qi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_IOR (V4QImode,
	operand1,
	operand2));
}

/* ../../gcc/config/sparc/sparc.md:8601 */
rtx
gen_andv4hi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_AND (V4HImode,
	operand1,
	operand2));
}

/* ../../gcc/config/sparc/sparc.md:8649 */
rtx
gen_one_cmplv4hi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_NOT (V4HImode,
	operand1));
}

/* ../../gcc/config/sparc/sparc.md:8746 */
rtx
gen_fmul8sux16_vis (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (V4HImode,
	gen_rtvec (2,
		operand1,
		operand2),
	60));
}

/* ../../gcc/config/sparc/sparc.md:8848 */
rtx
gen_faligndatav8qi_vis (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (V8QImode,
	gen_rtvec (3,
		operand1,
		operand2,
		gen_rtx_REG (DImode,
	102)),
	31));
}

/* ../../gcc/config/sparc/sparc.md:8941 */
rtx
gen_edge16si_vis (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (gen_rtx_REG (CCNZmode,
	100),
	gen_rtx_COMPARE (CCNZmode,
	gen_rtx_MINUS (SImode,
	operand1,
	operand2),
	const0_rtx)),
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (2,
		copy_rtx (operand1),
		copy_rtx (operand2)),
	35))));
}

/* ../../gcc/config/sparc/sparc.md:8990 */
rtx
gen_fpcmple8si_vis (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_LE (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/sparc/sparc.md:8990 */
rtx
gen_fpcmple16si_vis (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_LE (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/sparc/sparc.md:8990 */
rtx
gen_fpcmpeq16di_vis (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_EQ (DImode,
	operand1,
	operand2));
}

/* ../../gcc/config/sparc/sparc.md:9017 */
rtx
gen_fpcmpule16si_vis (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_LEU (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/sparc/sparc.md:9052 */
rtx
gen_array8si_vis (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (2,
		operand1,
		operand2),
	39));
}

/* ../../gcc/config/sparc/sparc.md:9099 */
rtx
gen_bshufflev4hi_vis (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (V4HImode,
	gen_rtvec (3,
		operand1,
		operand2,
		gen_rtx_REG (DImode,
	102)),
	50));
}

/* ../../gcc/config/sparc/sparc.md:9154 */
rtx
gen_edge16lnsi_vis (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (2,
		operand1,
		operand2),
	47));
}

/* ../../gcc/config/sparc/sparc.md:9202 */
rtx
gen_cmask32si_vis (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (gen_rtx_REG (DImode,
	102),
	gen_rtx_UNSPEC (DImode,
	gen_rtvec (2,
		operand0,
		gen_rtx_REG (DImode,
	102)),
	53));
}

/* ../../gcc/config/sparc/sparc.md:9230 */
rtx
gen_vashrv2si3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_ASHIFTRT (V2SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/sparc/sparc.md:9292 */
rtx
gen_ssaddv2si3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SS_PLUS (V2SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/sparc/sparc.md:9308 */
rtx
gen_maxv4hi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SMAX (V4HImode,
	operand1,
	operand2));
}

/* ../../gcc/config/sparc/sparc.md:9334 */
rtx
gen_sssubv8qi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SS_MINUS (V8QImode,
	operand1,
	operand2));
}

/* ../../gcc/config/sparc/sparc.md:9451 */
rtx
gen_fnhadddf_vis (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_NEG (DFmode,
	gen_rtx_UNSPEC (DFmode,
	gen_rtvec (2,
		operand1,
		operand2),
	56)));
}

/* ../../gcc/config/sparc/sparc.md:9480 */
rtx
gen_fpcmple16sishl (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (2,
		gen_rtx_LE (V4HImode,
	operand1,
	operand2),
		operand3),
	66));
}

/* ../../gcc/config/sparc/sparc.md:9480 */
rtx
gen_fpcmpeq16dishl (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (DImode,
	gen_rtvec (2,
		gen_rtx_EQ (V4HImode,
	operand1,
	operand2),
		operand3),
	66));
}

/* ../../gcc/config/sparc/sparc.md:9491 */
rtx
gen_fpcmpule16sishl (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (2,
		gen_rtx_LEU (V4HImode,
	operand1,
	operand2),
		operand3),
	67));
}

/* ../../gcc/config/sparc/sparc.md:9504 */
rtx
gen_fpcmpde8sishl (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (3,
		operand1,
		operand2,
		operand3),
	68));
}

/* ../../gcc/config/sparc/sparc.md:9518 */
rtx
gen_fpcmpur16dishl (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (DImode,
	gen_rtvec (3,
		operand1,
		operand2,
		operand3),
	69));
}

/* ../../gcc/config/sparc/sparc.md:794 */
rtx
gen_cstoresf4 (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[4];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 800 "../../gcc/config/sparc/sparc.md"
{
  if (emit_scc_insn (operands)) DONE; else FAIL;
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
    operand2 = operands[2];
    (void) operand2;
    operand3 = operands[3];
    (void) operand3;
  }
  emit_insn (gen_rtx_USE (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand1), VOIDmode,
		operand2,
		operand3)));
  emit_insn (gen_rtx_CLOBBER (VOIDmode,
	operand0));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:847 */
extern rtx_insn *gen_split_7 (rtx_insn *, rtx *);
rtx_insn *
gen_split_7 (rtx_insn *curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx_insn *_val = NULL;
  if (dump_file)
    fprintf (dump_file, "Splitting with gen_split_7 (sparc.md:847)\n");
  start_sequence ();
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 857 "../../gcc/config/sparc/sparc.md"

#undef DONE
#undef FAIL
  operand0 = operands[0];
  (void) operand0;
  operand1 = operands[1];
  (void) operand1;
  emit_insn (gen_rtx_SET (gen_rtx_REG (CCXCmode,
	100),
	gen_rtx_COMPARE (CCXCmode,
	gen_rtx_NOT (DImode,
	operand1),
	constm1_rtx)));
  emit_insn (gen_rtx_SET (operand0,
	gen_rtx_LTU (SImode,
	gen_rtx_REG (CCXCmode,
	100),
	const0_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:913 */
extern rtx_insn *gen_split_17 (rtx_insn *, rtx *);
rtx_insn *
gen_split_17 (rtx_insn *curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx_insn *_val = NULL;
  if (dump_file)
    fprintf (dump_file, "Splitting with gen_split_17 (sparc.md:913)\n");
  start_sequence ();
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 924 "../../gcc/config/sparc/sparc.md"

#undef DONE
#undef FAIL
  operand0 = operands[0];
  (void) operand0;
  operand1 = operands[1];
  (void) operand1;
  emit_insn (gen_rtx_SET (operand0,
	const0_rtx));
  emit_insn (gen_rtx_SET (copy_rtx (operand0),
	gen_rtx_IF_THEN_ELSE (SImode,
	gen_rtx_EQ (DImode,
	operand1,
	const0_rtx),
	const1_rtx,
	copy_rtx (operand0))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:975 */
extern rtx_insn *gen_split_26 (rtx_insn *, rtx *);
rtx_insn *
gen_split_26 (rtx_insn *curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx_insn *_val = NULL;
  if (dump_file)
    fprintf (dump_file, "Splitting with gen_split_26 (sparc.md:975)\n");
  start_sequence ();
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 987 "../../gcc/config/sparc/sparc.md"

#undef DONE
#undef FAIL
  operand0 = operands[0];
  (void) operand0;
  operand1 = operands[1];
  (void) operand1;
  operand2 = operands[2];
  (void) operand2;
  emit_insn (gen_rtx_SET (gen_rtx_REG (CCXCmode,
	100),
	gen_rtx_COMPARE (CCXCmode,
	gen_rtx_NOT (DImode,
	operand1),
	constm1_rtx)));
  emit_insn (gen_rtx_SET (operand0,
	gen_rtx_PLUS (DImode,
	gen_rtx_LTU (DImode,
	gen_rtx_REG (CCXCmode,
	100),
	const0_rtx),
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:1054 */
extern rtx_insn *gen_split_36 (rtx_insn *, rtx *);
rtx_insn *
gen_split_36 (rtx_insn *curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx_insn *_val = NULL;
  if (dump_file)
    fprintf (dump_file, "Splitting with gen_split_36 (sparc.md:1054)\n");
  start_sequence ();
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 1068 "../../gcc/config/sparc/sparc.md"

#undef DONE
#undef FAIL
  operand0 = operands[0];
  (void) operand0;
  operand1 = operands[1];
  (void) operand1;
  operand2 = operands[2];
  (void) operand2;
  operand3 = operands[3];
  (void) operand3;
  emit_insn (gen_rtx_SET (gen_rtx_REG (CCXCmode,
	100),
	gen_rtx_COMPARE (CCXCmode,
	gen_rtx_NOT (DImode,
	operand1),
	constm1_rtx)));
  emit_insn (gen_rtx_SET (operand0,
	gen_rtx_MINUS (DImode,
	gen_rtx_MINUS (DImode,
	operand2,
	gen_rtx_LTU (DImode,
	gen_rtx_REG (CCXCmode,
	100),
	const0_rtx)),
	operand3)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:1611 */
rtx
gen_movqi (rtx operand0,
	rtx operand1)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 1615 "../../gcc/config/sparc/sparc.md"
{
  if (sparc_expand_move (QImode, operands))
    DONE;
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
  }
  emit_insn (gen_rtx_SET (operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:2115 */
extern rtx_insn *gen_split_43 (rtx_insn *, rtx *);
rtx_insn *
gen_split_43 (rtx_insn *curr_insn ATTRIBUTE_UNUSED, rtx *operands ATTRIBUTE_UNUSED)
{
  rtx_insn *_val = NULL;
  if (dump_file)
    fprintf (dump_file, "Splitting with gen_split_43 (sparc.md:2115)\n");
  start_sequence ();
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 2126 "../../gcc/config/sparc/sparc.md"
{
  HOST_WIDE_INT low = trunc_int_for_mode (INTVAL (operands[1]), SImode);
  HOST_WIDE_INT high = trunc_int_for_mode (INTVAL (operands[1]) >> 32, SImode);
  rtx high_part = gen_highpart (SImode, operands[0]);
  rtx low_part = gen_lowpart (SImode, operands[0]);

  emit_move_insn_1 (high_part, GEN_INT (high));

  /* Slick... but this loses if the constant can be done in one insn.  */
  if (low == high && !SPARC_SETHI32_P (high) && !SPARC_SIMM13_P (high))
    emit_move_insn_1 (low_part, high_part);
  else
    emit_move_insn_1 (low_part, GEN_INT (low));

  DONE;
}
#undef DONE
#undef FAIL
  emit_insn (gen_rtx_CLOBBER (VOIDmode,
	const0_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:2558 */
extern rtx_insn *gen_split_54 (rtx_insn *, rtx *);
rtx_insn *
gen_split_54 (rtx_insn *curr_insn ATTRIBUTE_UNUSED, rtx *operands ATTRIBUTE_UNUSED)
{
  rtx_insn *_val = NULL;
  if (dump_file)
    fprintf (dump_file, "Splitting with gen_split_54 (sparc.md:2558)\n");
  start_sequence ();
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 2569 "../../gcc/config/sparc/sparc.md"
{
  emit_move_insn_1 (gen_highpart (SFmode, operands[0]), CONST0_RTX (SFmode));
  emit_move_insn_1 (gen_lowpart (SFmode, operands[0]), CONST0_RTX (SFmode));
  DONE;
}
#undef DONE
#undef FAIL
  emit_insn (gen_rtx_CLOBBER (VOIDmode,
	const0_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:2774 */
extern rtx_insn *gen_split_62 (rtx_insn *, rtx *);
rtx_insn *
gen_split_62 (rtx_insn *curr_insn ATTRIBUTE_UNUSED, rtx *operands ATTRIBUTE_UNUSED)
{
  rtx_insn *_val = NULL;
  if (dump_file)
    fprintf (dump_file, "Splitting with gen_split_62 (sparc.md:2774)\n");
  start_sequence ();
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 2783 "../../gcc/config/sparc/sparc.md"
{
  rtx set_src = operands[1];

  emit_insn (gen_movdf (adjust_address (operands[0], DFmode, 0),
			gen_df_reg (set_src, 0)));
  emit_insn (gen_movdf (adjust_address (operands[0], DFmode, 8),
			gen_df_reg (set_src, 1)));
  DONE;
}
#undef DONE
#undef FAIL
  emit_insn (gen_rtx_CLOBBER (VOIDmode,
	const0_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:2817 */
rtx
gen_movtfcc (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[4];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 2823 "../../gcc/config/sparc/sparc.md"
{
  if (!sparc_expand_conditional_move (TFmode, operands))
    FAIL;
  DONE;
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
    operand2 = operands[2];
    (void) operand2;
    operand3 = operands[3];
    (void) operand3;
  }
  emit_insn (gen_rtx_SET (operand0,
	gen_rtx_IF_THEN_ELSE (TFmode,
	operand1,
	operand2,
	operand3)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:3410 */
rtx
gen_extendhidi2 (rtx operand0,
	rtx operand1)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 3414 "../../gcc/config/sparc/sparc.md"
{
  rtx temp = gen_reg_rtx (DImode);
  rtx shift_48 = GEN_INT (48);
  int op1_subbyte = 0;

  if (GET_CODE (operand1) == SUBREG)
    {
      op1_subbyte = SUBREG_BYTE (operand1);
      op1_subbyte /= GET_MODE_SIZE (DImode);
      op1_subbyte *= GET_MODE_SIZE (DImode);
      operand1 = XEXP (operand1, 0);
    }

  emit_insn (gen_ashldi3 (temp, gen_rtx_SUBREG (DImode, operand1, op1_subbyte),
			  shift_48));
  emit_insn (gen_ashrdi3 (operand0, temp, shift_48));
  DONE;
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
  }
  emit_insn (gen_rtx_SET (operand0,
	gen_rtx_SIGN_EXTEND (DImode,
	operand1)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:3650 */
rtx
gen_floatunsditf2 (rtx operand0,
	rtx operand1)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 3654 "../../gcc/config/sparc/sparc.md"
emit_tfmode_cvt (UNSIGNED_FLOAT, operands); DONE;
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
  }
  emit_insn (gen_rtx_SET (operand0,
	gen_rtx_UNSIGNED_FLOAT (TFmode,
	operand1)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:3811 */
extern rtx_insn *gen_split_66 (rtx_insn *, rtx *);
rtx_insn *
gen_split_66 (rtx_insn *curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx operand4;
  rtx operand5;
  rtx operand6;
  rtx operand7;
  rtx operand8;
  rtx_insn *_val = NULL;
  if (dump_file)
    fprintf (dump_file, "Splitting with gen_split_66 (sparc.md:3811)\n");
  start_sequence ();
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 3827 "../../gcc/config/sparc/sparc.md"
{
  operands[3] = gen_lowpart (SImode, operands[0]);
  operands[4] = gen_lowpart (SImode, operands[1]);
  operands[5] = gen_lowpart (SImode, operands[2]);
  operands[6] = gen_highpart (SImode, operands[0]);
  operands[7] = gen_highpart_mode (SImode, DImode, operands[1]);
  operands[8] = gen_highpart_mode (SImode, DImode, operands[2]);
}
#undef DONE
#undef FAIL
  operand0 = operands[0];
  (void) operand0;
  operand1 = operands[1];
  (void) operand1;
  operand2 = operands[2];
  (void) operand2;
  operand3 = operands[3];
  (void) operand3;
  operand4 = operands[4];
  (void) operand4;
  operand5 = operands[5];
  (void) operand5;
  operand6 = operands[6];
  (void) operand6;
  operand7 = operands[7];
  (void) operand7;
  operand8 = operands[8];
  (void) operand8;
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (gen_rtx_REG (CCCmode,
	100),
	gen_rtx_COMPARE (CCCmode,
	gen_rtx_PLUS (SImode,
	operand4,
	operand5),
	copy_rtx (operand4))),
		gen_rtx_SET (operand3,
	gen_rtx_PLUS (SImode,
	copy_rtx (operand4),
	copy_rtx (operand5))))), true);
  emit_insn (gen_rtx_SET (operand6,
	gen_rtx_PLUS (SImode,
	gen_rtx_PLUS (SImode,
	operand7,
	operand8),
	gen_rtx_LTU (SImode,
	gen_rtx_REG (CCCmode,
	100),
	const0_rtx))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:4383 */
rtx
gen_usubvsi4 (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[4];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 4393 "../../gcc/config/sparc/sparc.md"
{
  if (operands[1] == const0_rtx)
    {
      emit_insn (gen_unegvsi3 (operands[0], operands[2], operands[3]));
      DONE;
    }
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
    operand2 = operands[2];
    (void) operand2;
    operand3 = operands[3];
    (void) operand3;
  }
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (gen_rtx_REG (CCmode,
	100),
	gen_rtx_COMPARE (CCmode,
	operand1,
	operand2)),
		gen_rtx_SET (operand0,
	gen_rtx_MINUS (SImode,
	copy_rtx (operand1),
	copy_rtx (operand2))))), true);
  emit_jump_insn (gen_rtx_SET (pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_LTU (VOIDmode,
	gen_rtx_REG (CCmode,
	100),
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand3),
	pc_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:5028 */
rtx
gen_umulxhi_vis (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 5036 "../../gcc/config/sparc/sparc.md"
{
  if (TARGET_ARCH32)
    {
      emit_insn (gen_umulxhi_v8plus (operands[0], operands[1], operands[2]));
      DONE;
    }
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
    operand2 = operands[2];
    (void) operand2;
  }
  emit_insn (gen_rtx_SET (operand0,
	gen_rtx_TRUNCATE (DImode,
	gen_rtx_LSHIFTRT (TImode,
	gen_rtx_MULT (TImode,
	gen_rtx_ZERO_EXTEND (TImode,
	operand1),
	gen_rtx_ZERO_EXTEND (TImode,
	operand2)),
	const_int_rtx[MAX_SAVED_CONST_INT + (64)]))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:5666 */
rtx
gen_unegvdi3 (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 5677 "../../gcc/config/sparc/sparc.md"
{
  if (TARGET_ARCH32)
    {
      emit_insn (gen_unegvdi3_sp32 (operands[0], operands[1]));
      rtx x = gen_rtx_LTU (VOIDmode, gen_rtx_REG (CCCmode, SPARC_ICC_REG),
				     const0_rtx);
      emit_jump_insn (gen_cbranchcc4 (x, XEXP (x, 0), XEXP (x, 1), operands[2]));
      DONE;
    }
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
    operand2 = operands[2];
    (void) operand2;
  }
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (gen_rtx_REG (CCXCmode,
	100),
	gen_rtx_COMPARE (CCXCmode,
	gen_rtx_NOT (DImode,
	operand1),
	constm1_rtx)),
		gen_rtx_SET (operand0,
	gen_rtx_NEG (DImode,
	copy_rtx (operand1))))), true);
  emit_jump_insn (gen_rtx_SET (pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_LTU (VOIDmode,
	gen_rtx_REG (CCXCmode,
	100),
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand2),
	pc_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:6250 */
rtx
gen_negtf2 (rtx operand0,
	rtx operand1)
{
  return gen_rtx_SET (operand0,
	gen_rtx_NEG (TFmode,
	operand1));
}

/* ../../gcc/config/sparc/sparc.md:6304 */
extern rtx_insn *gen_split_84 (rtx_insn *, rtx *);
rtx_insn *
gen_split_84 (rtx_insn *curr_insn ATTRIBUTE_UNUSED, rtx *operands ATTRIBUTE_UNUSED)
{
  rtx_insn *_val = NULL;
  if (dump_file)
    fprintf (dump_file, "Splitting with gen_split_84 (sparc.md:6304)\n");
  start_sequence ();
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 6311 "../../gcc/config/sparc/sparc.md"
{
  rtx set_dest = operands[0];
  rtx set_src = operands[1];
  rtx dest1, dest2;
  rtx src1, src2;

  dest1 = gen_highpart (SFmode, set_dest);
  dest2 = gen_lowpart (SFmode, set_dest);
  src1 = gen_highpart (SFmode, set_src);
  src2 = gen_lowpart (SFmode, set_src);

  /* Now emit using the real source and destination we found, swapping
     the order if we detect overlap.  */
  if (reg_overlap_mentioned_p (dest1, src2))
    {
      emit_insn (gen_movsf (dest2, src2));
      emit_insn (gen_negsf2 (dest1, src1));
    }
  else
    {
      emit_insn (gen_negsf2 (dest1, src1));
      if (REGNO (dest2) != REGNO (src2))
	emit_insn (gen_movsf (dest2, src2));
    }
  DONE;
}
#undef DONE
#undef FAIL
  emit_insn (gen_rtx_CLOBBER (VOIDmode,
	const0_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:7118 */
rtx
gen_sibcall_value (rtx operand0,
	rtx operand1)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_CALL (VOIDmode,
	operand1,
	const0_rtx)),
		ret_rtx));
}

/* ../../gcc/config/sparc/sparc.md:7203 */
rtx
gen_return (void)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 7206 "../../gcc/config/sparc/sparc.md"
{
  if (cfun->calls_alloca)
    emit_insn (gen_frame_blockage ());
}
#undef DONE
#undef FAIL
  }
  emit_jump_insn (ret_rtx);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:7365 */
rtx
gen_indirect_jump (rtx operand0)
{
  return gen_rtx_SET (pc_rtx,
	operand0);
}

/* ../../gcc/config/sparc/sparc.md:7395 */
rtx
gen_nonlocal_goto (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[4];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 7401 "../../gcc/config/sparc/sparc.md"
{
  rtx i7 = gen_rtx_REG (Pmode, RETURN_ADDR_REGNUM);
  rtx r_label = operands[1];
  rtx r_sp = adjust_address (operands[2], Pmode, 0);
  rtx r_fp = operands[3];
  rtx r_i7 = adjust_address (operands[2], Pmode, GET_MODE_SIZE (Pmode));

  /* We need to flush all the register windows so that their contents will
     be re-synchronized by the restore insn of the target function.  */
  if (!TARGET_FLAT)
    emit_insn (gen_flush_register_windows ());

  emit_clobber (gen_rtx_MEM (BLKmode, gen_rtx_SCRATCH (VOIDmode)));
  emit_clobber (gen_rtx_MEM (BLKmode, hard_frame_pointer_rtx));

  r_label = copy_to_reg (r_label);

  /* Restore the frame pointer and stack pointer.  We must use a
     temporary since the setjmp buffer may be a local.  */
  r_fp = copy_to_reg (r_fp);
  emit_stack_restore (SAVE_NONLOCAL, r_sp);
  r_i7 = copy_to_reg (r_i7);

  /* Ensure the frame pointer move is not optimized.  */
  emit_insn (gen_blockage ());
  emit_clobber (hard_frame_pointer_rtx);
  emit_move_insn (hard_frame_pointer_rtx, r_fp);
  emit_move_insn (i7, r_i7);

  /* USE of hard_frame_pointer_rtx added for consistency;
     not clear if really needed.  */
  emit_use (hard_frame_pointer_rtx);
  emit_use (stack_pointer_rtx);
  emit_use (i7);

  emit_indirect_jump (r_label);
  DONE;
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
    operand2 = operands[2];
    (void) operand2;
    operand3 = operands[3];
    (void) operand3;
  }
  emit (operand0, true);
  emit (operand1, true);
  emit (operand2, true);
  emit (operand3, false);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:8323 */
rtx
gen_stack_protect_set (rtx operand0,
	rtx operand1)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 8327 "../../gcc/config/sparc/sparc.md"
{
#ifdef TARGET_THREAD_SSP_OFFSET
  rtx tlsreg = gen_rtx_REG (Pmode, 7);
  rtx addr = gen_rtx_PLUS (Pmode, tlsreg, GEN_INT (TARGET_THREAD_SSP_OFFSET));
  operands[1] = gen_rtx_MEM (Pmode, addr);
#endif
  if (TARGET_ARCH64)
    emit_insn (gen_stack_protect_set64 (operands[0], operands[1]));
  else
    emit_insn (gen_stack_protect_set32 (operands[0], operands[1]));
  DONE;
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
  }
  emit (operand0, true);
  emit (operand1, false);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:8516 */
extern rtx_insn *gen_split_91 (rtx_insn *, rtx *);
rtx_insn *
gen_split_91 (rtx_insn *curr_insn ATTRIBUTE_UNUSED, rtx *operands ATTRIBUTE_UNUSED)
{
  rtx_insn *_val = NULL;
  if (dump_file)
    fprintf (dump_file, "Splitting with gen_split_91 (sparc.md:8516)\n");
  start_sequence ();
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 8524 "../../gcc/config/sparc/sparc.md"
{
  sparc_split_reg_reg (operands[0], operands[1], SImode);
  DONE;
}
#undef DONE
#undef FAIL
  emit_insn (gen_rtx_CLOBBER (VOIDmode,
	const0_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:8555 */
extern rtx_insn *gen_split_101 (rtx_insn *, rtx *);
rtx_insn *
gen_split_101 (rtx_insn *curr_insn ATTRIBUTE_UNUSED, rtx *operands ATTRIBUTE_UNUSED)
{
  rtx_insn *_val = NULL;
  if (dump_file)
    fprintf (dump_file, "Splitting with gen_split_101 (sparc.md:8555)\n");
  start_sequence ();
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 8564 "../../gcc/config/sparc/sparc.md"
{
  emit_move_insn_1 (adjust_address (operands[0], SImode, 0), const0_rtx);
  emit_move_insn_1 (adjust_address (operands[0], SImode, 4), const0_rtx);
  DONE;
}
#undef DONE
#undef FAIL
  emit_insn (gen_rtx_CLOBBER (VOIDmode,
	const0_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:8786 */
rtx
gen_wrgsr_vis (rtx operand0)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[1];
    operands[0] = operand0;
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 8789 "../../gcc/config/sparc/sparc.md"
{
  if (TARGET_ARCH32)
    {
      emit_insn (gen_wrgsr_v8plus (operands[0]));
      DONE;
    }
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
  }
  emit_insn (gen_rtx_SET (gen_rtx_REG (DImode,
	102),
	operand0));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:9025 */
rtx
gen_vec_cmpuv4hisi (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[4];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 9031 "../../gcc/config/sparc/sparc.md"
{
  enum rtx_code code = GET_CODE (operands[1]);

  if (code == LTU || code == GEU)
    {
      PUT_CODE (operands[1], swap_condition (code));
      std::swap (operands[2], operands[3]);
    }
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
    operand2 = operands[2];
    (void) operand2;
    operand3 = operands[3];
    (void) operand3;
  }
  emit_insn (gen_rtx_SET (operand0,
	gen_rtx_fmt_ee (GET_CODE (operand1), SImode,
		operand2,
		operand3)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sparc.md:9041 */
rtx
gen_vcond_mask_v2sidi (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[4];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;
#define FAIL _Pragma ("GCC error \"vcond_mask_v2sidi cannot FAIL\"") (void)0
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 9047 "../../gcc/config/sparc/sparc.md"
{
  sparc_expand_vcond_mask (V2SImode, operands, UNSPEC_CMASK32);
  DONE;
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
    operand2 = operands[2];
    (void) operand2;
    operand3 = operands[3];
    (void) operand3;
  }
  emit (operand0, true);
  emit (operand1, true);
  emit (operand2, true);
  emit (operand3, false);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sync.md:121 */
rtx
gen_atomic_loadsi (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 126 "../../gcc/config/sparc/sync.md"
{
  enum memmodel model = (enum memmodel) INTVAL (operands[2]);

  sparc_emit_membar_for_model (model, 1, 1);

  if (TARGET_ARCH64 || SImode != DImode)
    emit_move_insn (operands[0], operands[1]);
  else
    emit_insn (gen_atomic_loaddi_1 (operands[0], operands[1]));

  sparc_emit_membar_for_model (model, 1, 2);
  DONE;
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
    operand2 = operands[2];
    (void) operand2;
  }
  emit (operand0, true);
  emit (operand1, true);
  emit (operand2, false);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/sparc/sync.md:196 */
rtx
gen_atomic_compare_and_swapsi_1 (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (operand1,
	gen_rtx_UNSPEC_VOLATILE (SImode,
	gen_rtvec (2,
		operand2,
		operand3),
	8))));
}



void
add_clobbers (rtx pattern ATTRIBUTE_UNUSED, int insn_code_number)
{
  switch (insn_code_number)
    {
    case 420:
    case 419:
    case 418:
    case 417:
      XVECEXP (pattern, 0, 2) = gen_hard_reg_clobber (SImode, 15);
      break;

    case 526:
    case 294:
      XVECEXP (pattern, 0, 2) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode));
      break;

    case 646:
    case 644:
    case 452:
    case 448:
    case 404:
    case 398:
    case 390:
    case 291:
    case 282:
    case 281:
    case 280:
    case 275:
    case 272:
    case 271:
    case 270:
    case 265:
    case 264:
      XVECEXP (pattern, 0, 1) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode));
      break;

    case 290:
    case 288:
    case 286:
    case 262:
      XVECEXP (pattern, 0, 1) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode));
      XVECEXP (pattern, 0, 2) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode));
      break;

    case 475:
    case 467:
    case 424:
    case 422:
    case 416:
    case 414:
    case 112:
      XVECEXP (pattern, 0, 1) = gen_hard_reg_clobber (DImode, 15);
      break;

    case 474:
    case 466:
    case 423:
    case 421:
    case 415:
    case 413:
    case 111:
      XVECEXP (pattern, 0, 1) = gen_hard_reg_clobber (SImode, 15);
      break;

    case 46:
    case 45:
    case 44:
    case 43:
    case 38:
    case 37:
    case 36:
    case 35:
    case 22:
    case 21:
    case 18:
    case 17:
      XVECEXP (pattern, 0, 1) = gen_hard_reg_clobber (CCXmode, 100);
      break;

    case 326:
    case 244:
    case 240:
    case 223:
    case 219:
    case 50:
    case 49:
    case 48:
    case 47:
    case 42:
    case 41:
    case 40:
    case 39:
    case 34:
    case 33:
    case 32:
    case 31:
    case 26:
    case 25:
    case 24:
    case 23:
    case 14:
    case 13:
    case 12:
    case 11:
      XVECEXP (pattern, 0, 1) = gen_hard_reg_clobber (CCmode, 100);
      break;

    default:
      gcc_unreachable ();
    }
}


bool
added_clobbers_hard_reg_p (int insn_code_number)
{
  switch (insn_code_number)
    {
    case 526:
    case 294:
    case 646:
    case 644:
    case 452:
    case 448:
    case 404:
    case 398:
    case 390:
    case 291:
    case 282:
    case 281:
    case 280:
    case 275:
    case 272:
    case 271:
    case 270:
    case 265:
    case 264:
    case 290:
    case 288:
    case 286:
    case 262:
      return false;

    case 420:
    case 419:
    case 418:
    case 417:
    case 475:
    case 467:
    case 424:
    case 422:
    case 416:
    case 414:
    case 112:
    case 474:
    case 466:
    case 423:
    case 421:
    case 415:
    case 413:
    case 111:
    case 46:
    case 45:
    case 44:
    case 43:
    case 38:
    case 37:
    case 36:
    case 35:
    case 22:
    case 21:
    case 18:
    case 17:
    case 326:
    case 244:
    case 240:
    case 223:
    case 219:
    case 50:
    case 49:
    case 48:
    case 47:
    case 42:
    case 41:
    case 40:
    case 39:
    case 34:
    case 33:
    case 32:
    case 31:
    case 26:
    case 25:
    case 24:
    case 23:
    case 14:
    case 13:
    case 12:
    case 11:
      return true;

    default:
      gcc_unreachable ();
    }
}

insn_code
maybe_code_for_load_pcrel_sym (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_load_pcrel_symsi;
  if (arg0 == E_DImode)
    return CODE_FOR_load_pcrel_symdi;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_load_pcrel_sym (machine_mode arg0, rtx x0, rtx x1, rtx x2, rtx x3)
{
  insn_code code = maybe_code_for_load_pcrel_sym (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 4);
      return GEN_FCN (code) (x0, x1, x2, x3);
    }
  else
    return NULL_RTX;
}

insn_code
maybe_code_for_probe_stack_range (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_probe_stack_rangesi;
  if (arg0 == E_DImode)
    return CODE_FOR_probe_stack_rangedi;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_probe_stack_range (machine_mode arg0, rtx x0, rtx x1, rtx x2)
{
  insn_code code = maybe_code_for_probe_stack_range (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 3);
      return GEN_FCN (code) (x0, x1, x2);
    }
  else
    return NULL_RTX;
}

insn_code
maybe_code_for_flush (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_flushsi;
  if (arg0 == E_DImode)
    return CODE_FOR_flushdi;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_flush (machine_mode arg0, rtx x0)
{
  insn_code code = maybe_code_for_flush (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 1);
      return GEN_FCN (code) (x0);
    }
  else
    return NULL_RTX;
}

insn_code
maybe_code_for_tgd_hi22 (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_tgd_hi22si;
  if (arg0 == E_DImode)
    return CODE_FOR_tgd_hi22di;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_tgd_hi22 (machine_mode arg0, rtx x0, rtx x1)
{
  insn_code code = maybe_code_for_tgd_hi22 (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 2);
      return GEN_FCN (code) (x0, x1);
    }
  else
    return NULL_RTX;
}

insn_code
maybe_code_for_tgd_lo10 (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_tgd_lo10si;
  if (arg0 == E_DImode)
    return CODE_FOR_tgd_lo10di;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_tgd_lo10 (machine_mode arg0, rtx x0, rtx x1, rtx x2)
{
  insn_code code = maybe_code_for_tgd_lo10 (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 3);
      return GEN_FCN (code) (x0, x1, x2);
    }
  else
    return NULL_RTX;
}

insn_code
maybe_code_for_tgd_add (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_tgd_addsi;
  if (arg0 == E_DImode)
    return CODE_FOR_tgd_adddi;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_tgd_add (machine_mode arg0, rtx x0, rtx x1, rtx x2, rtx x3)
{
  insn_code code = maybe_code_for_tgd_add (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 4);
      return GEN_FCN (code) (x0, x1, x2, x3);
    }
  else
    return NULL_RTX;
}

insn_code
maybe_code_for_tgd_call (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_tgd_callsi;
  if (arg0 == E_DImode)
    return CODE_FOR_tgd_calldi;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_tgd_call (machine_mode arg0, rtx x0, rtx x1, rtx x2, rtx x3)
{
  insn_code code = maybe_code_for_tgd_call (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 4);
      return GEN_FCN (code) (x0, x1, x2, x3);
    }
  else
    return NULL_RTX;
}

insn_code
maybe_code_for_tldm_hi22 (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_tldm_hi22si;
  if (arg0 == E_DImode)
    return CODE_FOR_tldm_hi22di;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_tldm_hi22 (machine_mode arg0, rtx x0)
{
  insn_code code = maybe_code_for_tldm_hi22 (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 1);
      return GEN_FCN (code) (x0);
    }
  else
    return NULL_RTX;
}

insn_code
maybe_code_for_tldm_lo10 (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_tldm_lo10si;
  if (arg0 == E_DImode)
    return CODE_FOR_tldm_lo10di;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_tldm_lo10 (machine_mode arg0, rtx x0, rtx x1)
{
  insn_code code = maybe_code_for_tldm_lo10 (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 2);
      return GEN_FCN (code) (x0, x1);
    }
  else
    return NULL_RTX;
}

insn_code
maybe_code_for_tldm_add (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_tldm_addsi;
  if (arg0 == E_DImode)
    return CODE_FOR_tldm_adddi;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_tldm_add (machine_mode arg0, rtx x0, rtx x1, rtx x2)
{
  insn_code code = maybe_code_for_tldm_add (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 3);
      return GEN_FCN (code) (x0, x1, x2);
    }
  else
    return NULL_RTX;
}

insn_code
maybe_code_for_tldm_call (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_tldm_callsi;
  if (arg0 == E_DImode)
    return CODE_FOR_tldm_calldi;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_tldm_call (machine_mode arg0, rtx x0, rtx x1, rtx x2)
{
  insn_code code = maybe_code_for_tldm_call (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 3);
      return GEN_FCN (code) (x0, x1, x2);
    }
  else
    return NULL_RTX;
}

insn_code
maybe_code_for_tldo_hix22 (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_tldo_hix22si;
  if (arg0 == E_DImode)
    return CODE_FOR_tldo_hix22di;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_tldo_hix22 (machine_mode arg0, rtx x0, rtx x1)
{
  insn_code code = maybe_code_for_tldo_hix22 (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 2);
      return GEN_FCN (code) (x0, x1);
    }
  else
    return NULL_RTX;
}

insn_code
maybe_code_for_tldo_lox10 (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_tldo_lox10si;
  if (arg0 == E_DImode)
    return CODE_FOR_tldo_lox10di;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_tldo_lox10 (machine_mode arg0, rtx x0, rtx x1, rtx x2)
{
  insn_code code = maybe_code_for_tldo_lox10 (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 3);
      return GEN_FCN (code) (x0, x1, x2);
    }
  else
    return NULL_RTX;
}

insn_code
maybe_code_for_tldo_add (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_tldo_addsi;
  if (arg0 == E_DImode)
    return CODE_FOR_tldo_adddi;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_tldo_add (machine_mode arg0, rtx x0, rtx x1, rtx x2, rtx x3)
{
  insn_code code = maybe_code_for_tldo_add (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 4);
      return GEN_FCN (code) (x0, x1, x2, x3);
    }
  else
    return NULL_RTX;
}

insn_code
maybe_code_for_tie_hi22 (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_tie_hi22si;
  if (arg0 == E_DImode)
    return CODE_FOR_tie_hi22di;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_tie_hi22 (machine_mode arg0, rtx x0, rtx x1)
{
  insn_code code = maybe_code_for_tie_hi22 (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 2);
      return GEN_FCN (code) (x0, x1);
    }
  else
    return NULL_RTX;
}

insn_code
maybe_code_for_tie_lo10 (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_tie_lo10si;
  if (arg0 == E_DImode)
    return CODE_FOR_tie_lo10di;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_tie_lo10 (machine_mode arg0, rtx x0, rtx x1, rtx x2)
{
  insn_code code = maybe_code_for_tie_lo10 (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 3);
      return GEN_FCN (code) (x0, x1, x2);
    }
  else
    return NULL_RTX;
}

insn_code
maybe_code_for_tie_add (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_tie_addsi;
  if (arg0 == E_DImode)
    return CODE_FOR_tie_adddi;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_tie_add (machine_mode arg0, rtx x0, rtx x1, rtx x2, rtx x3)
{
  insn_code code = maybe_code_for_tie_add (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 4);
      return GEN_FCN (code) (x0, x1, x2, x3);
    }
  else
    return NULL_RTX;
}

insn_code
maybe_code_for_tle_hix22 (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_tle_hix22si;
  if (arg0 == E_DImode)
    return CODE_FOR_tle_hix22di;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_tle_hix22 (machine_mode arg0, rtx x0, rtx x1)
{
  insn_code code = maybe_code_for_tle_hix22 (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 2);
      return GEN_FCN (code) (x0, x1);
    }
  else
    return NULL_RTX;
}

insn_code
maybe_code_for_tle_lox10 (machine_mode arg0)
{
  if (arg0 == E_SImode)
    return CODE_FOR_tle_lox10si;
  if (arg0 == E_DImode)
    return CODE_FOR_tle_lox10di;
  return CODE_FOR_nothing;
}

rtx
maybe_gen_tle_lox10 (machine_mode arg0, rtx x0, rtx x1, rtx x2)
{
  insn_code code = maybe_code_for_tle_lox10 (arg0);
  if (code != CODE_FOR_nothing)
    {
      gcc_assert (insn_data[code].n_generator_args == 3);
      return GEN_FCN (code) (x0, x1, x2);
    }
  else
    return NULL_RTX;
}
